#ifndef MENU
#define MENU
#include <avr/pgmspace.h>
#include "Arduino.h"
#define PS __attribute__((section (".progmem.data")))

#include <stdio.h>

#define START 0
#define Z1    1
#define Z2    2
#define Z3    3
#define Z1A   4
#define Z1B    5
#define Z2A   6
#define Z2B    7
#define ERROR  99

#define RESET 2
#define OK 3
#define SET 1


typedef struct PROGMEM{
	uint8_t state ;
	uint8_t nextState ;
	uint8_t input ;
} TRANSITION_INFO;

typedef struct PROGMEM{
	uint8_t state;
	PGM_P text ;
	void (*p)(void) ;
} STATE_INFO;

uint8_t nextstate(uint8_t s, uint8_t in);
void stateAction(uint8_t state);
STATE_INFO getStateInfo(uint8_t s);

extern PROGMEM const char startText[];
extern PROGMEM const char z1Text[];
extern PROGMEM const char z1aText[];
extern PROGMEM const char z1bText[];
extern PROGMEM const char z2Text[];
extern PROGMEM const char z2aText[];
extern PROGMEM const char z2bText[];
extern PROGMEM const char z3Text[];
extern PROGMEM const char z4Text[];
extern PROGMEM const char errorText[];



const TRANSITION_INFO transitions [] PS = {  
	{ START,  Z1      ,SET  },
	{ Z1,     Z2      ,SET  },
	{ Z1,     Z1A     ,OK  },
	{ Z2,     START   ,SET  },
	{ Z1A,    Z1A     ,SET  },
	{ Z1A,    Z1B     ,OK  },
	{ Z1B,    Z1A     ,SET  },
	{ Z2,     Z2A     ,OK  },
	{ Z2A,    Z2B     ,OK  },
	{ Z2A,    Z2A     ,SET  },
	{ Z2B,    Z2A     ,SET  },
	{ ERROR,  START   ,RESET  },
	{ Z1   ,  START   ,RESET  },
	{ Z1A,  START   ,RESET  },
	{ Z1B,  START   ,RESET  },
	{ Z2,  START   ,RESET  },
	{ Z2A,  START   ,RESET  },
	{ Z2B,  START   ,RESET  },
		
};


// the state, a text, a function name to call when not NULL
extern void hallomessage ();
extern void autosearch ();
const STATE_INFO states [] PS = {
	{ START,startText, hallomessage},
	{ Z1,z1Text, NULL},
	{ Z1A,z1aText, autosearch},
	{ Z1B,z1bText, NULL},
	{ Z2,z2Text, NULL},
	{ Z2A,z2aText, NULL},
	{ Z2B,z2bText, NULL},
	{ ERROR,errorText, NULL}
};



#endif